require 'json'

vals = [
  { n: 7, r: 0.2 },
  { n: 13, r: 0.3 },
  { n: 17, r: 0.4 },
]

vs = []
anglesList = []
vals.each do |val|
  angles = []
  val[:n].times do |i|
    angle = -0.5 * Math::PI - i * 2 * Math::PI / val[:n]
    angles << angle
    vs << {
      "x" => (0.5 + val[:r] * Math.cos(angle)).round(5),
      "y" => (0.5 + val[:r] * Math.sin(angle)).round(5)
    }
  end
  anglesList << angles
end

es = []
base = 0
vals.each_with_index do |val, i|
  val[:n].times do |j|
    ps = []
    s = 3
    (s-1).times do |k|
      angle = -0.5 * Math::PI - (j + (k+1) / s.to_f) * 2 * Math::PI / val[:n]
      ps << {
        "x" => (0.5 + val[:r] * Math.cos(angle)).round(5),
        "y" => (0.5 + val[:r] * Math.sin(angle)).round(5)
      }
    end
    es << { "from": base + j, "to": base + (j+1) % val[:n], "spline_middle_points" => ps }
  end
  base += val[:n]
end

puts JSON.pretty_generate({
  "vertices" => vs,
  "edges" => es,
  "random_mines" => {
    "mines_count": 10,
  },
})

